package com.herdt.javxml.kap05;

import org.xml.sax.helpers.*;
import org.xml.sax.*;

public class SAX1
{

  public SAX1()
  {
    try
    {
      XMLReader xml_reader = XMLReaderFactory.createXMLReader("org.apache.xerces.parsers.SAXParser");
      //XMLReader xml_reader = XMLReaderFactory.createXMLReader();  Standarsparser verwenden
      ContentHandler ch = new MyHandler();
      xml_reader.setContentHandler(ch);
      xml_reader.parse("com\\herdt\\javxml\\kap05\\Buecher2.xml");
    }
    catch(SAXException se)
    {
      System.out.println("Fehler: " + se.getMessage());
    }
    catch(Exception e)
    {
      System.out.println("Unknown Fehler: " + e.getMessage());
    }
  }

  public static void main(String[] args)
  {
    SAX1 SAX11 = new SAX1();
  }

}

class MyHandler implements ContentHandler
{
   static int hierarchischeEbene = 0;
   private boolean hatInhalt = false;
   private Locator loc;
   public void setDocumentLocator(Locator locator)
   {
     loc = locator;
     System.out.println("Locator gesetzt");
   }
   public void startPrefixMapping(String prefix, String uri) throws SAXException
   {
     System.out.println("Namensraum " + prefix + " fuer die URI " + uri + " definiert");
   }
   public void endPrefixMapping(String prefix) throws SAXException
   {
     System.out.println("\n\nEnde des Namensraums " + prefix);
   }
   public void ignorableWhitespace(char[] ch, int start, int length)
        throws SAXException
   {
     System.out.println("Whitespace: " + new String(ch, start, length));
   }
   public void processingInstruction(String target, String data)
        throws SAXException
   {
     System.out.println("Processing Instruction: " + target + ": " + data);
   }
   public void skippedEntity(String name) throws SAXException
   {
     System.out.println("Entry bersprungen: " + name);
   }
   public void startDocument() throws SAXException
   {
     System.out.println("----  XML-Dokument Beginn  ----");
   }
   public void endDocument() throws SAXException
   {
     System.out.println("----  XML-Dokument Ende  ----");
   }
   public void startElement(String namespaceURI, String localName, String qName,
                     Attributes atts) throws SAXException
   {
     if(hatInhalt)
       hatInhalt = false;
     else
       System.out.println();
     System.out.print("Zeile " + loc.getLineNumber() + ": ");
     for(int j = 0; j < hierarchischeEbene; j++)
       System.out.print("  ");
     System.out.print(localName);
     for(int i = 0; i < atts.getLength(); i++)
       {
         System.out.print("  " + atts.getLocalName(i) + " = " + atts.getValue(i));
       }
     hierarchischeEbene++;
   }
   public void endElement(String namespaceURI, String localName, String qName)
        throws SAXException
   {
     hierarchischeEbene--;
   }
   public void characters(char[] ch, int start, int length) throws SAXException
   {
     String s = (new String(ch, start, length)).trim();
     if(s.length() > 0)
     {
       System.out.println("   " + s);
       hatInhalt = true;
     }
   }
}
