package com.herdt.javxml.kap05;

import org.xml.sax.*;
import org.xml.sax.helpers.*;
import java.io.*;
import java.util.*;

public class Uebung2 extends DefaultHandler
{
  XMLReader xml_reader;
  static boolean docOK = true;
  static ArrayList docStruc = new ArrayList();
  static int anzElemente = 0;

  public Uebung2()
  {
    try
    {
      xml_reader = XMLReaderFactory.createXMLReader("org.apache.xerces.parsers.SAXParser");
      xml_reader.setFeature("http://xml.org/sax/features/validation", true);
      xml_reader.setFeature("http://apache.org/xml/features/validation/schema", true);
      xml_reader.setFeature("http://apache.org/xml/features/validation/dynamic", true);
      System.out.println("--- Schema-Validierung eingeschalten ---");
      xml_reader.setContentHandler(this);
      xml_reader.setErrorHandler(this);
      InputSource is = new InputSource("com\\herdt\\javxml\\kap05\\Buecher.xml");
      xml_reader.parse(is);
    }
    catch(SAXException saxe)
    {
      System.out.println("!  ---  Fehler beim Parsen  ---  !");
      docOK = false;
    }
    catch(IOException ioe)
    {
      System.out.println("E/A-Fehler: " + ioe.getMessage());
      docOK = false;
    }
  }

  public static void main(String[] args)
  {
    new Uebung2();

    if(docOK)
    {
      System.out.println("\n *** Inhalt der Dokuments ***\n");
      Iterator it = docStruc.iterator();
      while(it.hasNext())
        ((Elemente)it.next()).ausgeben();
    }
  }

  // ContentHandler
  int tab = 0;
  private boolean hatZeichen = false;
  static StringBuffer doc = new StringBuffer();

  public void processingInstruction(String target, String data) throws SAXException
  {
    System.out.println("Processing Instruction: " + target + ": " + data);
  }
  public void startElement(String namespaceURI, String localName, String qName, Attributes atts) throws SAXException
  {
    if((localName.equals("Buecher") && tab == 0) ||
       (localName.equals("Buch") && tab == 1) ||
       (localName.equals("Titel") && tab == 2) ||
       (localName.equals("Autor") && tab == 2)||
       (localName.equals("Vorname") && tab == 3)||
       (localName.equals("Nachname") && tab == 3)||
       (localName.equals("Gebdat") && tab == 3)||
       (localName.equals("Img") && tab == 3))
      {
        anzElemente++;
        Elemente el = new Elemente();
        el.name = localName;
        el.stufe = tab;
        el.attribute = new AttributesImpl(atts);
        for(int i = 0; i < atts.getLength(); i++)
          el.attribute.setAttribute(i, atts.getURI(i), atts.getLocalName(i),
                                    atts.getQName(i), atts.getType(i), atts.getValue(i));
        docStruc.add(el);
      }
    tab++;
  }
  public void endElement(String namespaceURI, String localName, String qName) throws SAXException
  {
    tab--;
  }
  public void characters(char[] ch, int start, int length) throws SAXException
  {
    String s = (new String(ch, start, length)).trim();
    if(s.length() > 0)
      ((Elemente)docStruc.get(anzElemente-1)).inhalt = s;
  }

  // Methoden des ErrorHandlers
  public void warning(SAXParseException ex)
  {
    System.out.println("\n! Warnung: " + ex.getSystemId() +
                       "; Zeile " + ex.getLineNumber() + ": \n" + ex.getMessage());
  }
  public void error(SAXParseException ex)
  {
    System.out.println("\n! ! Fehler: " + ex.getSystemId() +
                       "; Zeile " + ex.getLineNumber() + ": \n" + ex.getMessage());
  }
  public void fatalError(SAXParseException ex)
  {
    System.out.println("\n! ! ! schwerer Fehler: " + ex.getSystemId() +
                       "; Zeile " + ex.getLineNumber() + ": \n" + ex.getMessage());
  }
}

class Elemente
{
  int stufe;
  String name;
  AttributesImpl attribute;
  String inhalt;

  public void ausgeben()
  {
    for(int i = 0; i < stufe; i++)
      System.out.print("  ");

    System.out.print("<" + name + "> ");

    for(int i = 0; i < attribute.getLength(); i++)
      System.out.print(attribute.getLocalName(i) + " = " + attribute.getValue(i) + " ");

    if(inhalt == null)
      System.out.println();
    else
      System.out.println(inhalt);
  }
}




