package com.herdt.javxml.kap06;

import java.io.*;
import org.w3c.dom.*;
import org.apache.xerces.dom.DOMImplementationImpl;
import org.apache.xml.serialize.*;

public class DOMErstellen2
{

  public static void main(String[] args)
  {
    DOMErstellen2 dom1 = new DOMErstellen2();
    dom1.erzeugeDOM();
  }

  static void erzeugeDOM()
  {
    DOMImplementationImpl domImpl = new DOMImplementationImpl();
    Document doc = domImpl.createDocument(null, "NeueSchriftsteller", null);
    DocumentType dt = domImpl.createDocumentType("NeueSchriftsteller", null, "NeueSchriftsteller.dtd");
    try
    {
      doc.appendChild(dt);
      ProcessingInstruction pi = doc.createProcessingInstruction("xml-stylesheet",
                                 "type=\"text/xsl\" href=\"Schriftsteller.xsl\"");
      doc.appendChild(pi);

      // Wurzelknoten
      Element el_1 = doc.getDocumentElement();

      Comment c = doc.createComment("Schriftsteller der Gegenwart");
      el_1.appendChild(c);

      // schriftsteller 1
      Element el_2 = doc.createElement("Schriftsteller");
      el_1.appendChild(el_2);
      Element el_31 = doc.createElement("Name");
      el_2.appendChild(el_31);
      Text text = doc.createTextNode("Guenther Grass");
      el_31.appendChild(text);
      Element el_32 = doc.createElement("Werk");
      el_2.appendChild(el_32);
      text = doc.createTextNode("Die Blechtrommel");
      el_32.appendChild(text);
      el_32.setAttribute("Erscheinungsjahr", "1959");
      Attr at = doc.createAttribute("Art");
      at.setNodeValue("Roman");
      el_32.setAttributeNode(at);   // Alternative: el_32.setAttribute("ART", "Roman");

      // schriftsteller 2
      el_2 = doc.createElement("Schriftsteller");
      el_1.appendChild(el_2);
      el_31 = doc.createElement("Name");
      el_2.appendChild(el_31);
      text = doc.createTextNode("Eva Strittmatter");
      el_31.appendChild(text);
      el_32 = doc.createElement("Werk");
      el_2.appendChild(el_32);
      text = doc.createTextNode("Ich mach ein Lied aus Stille");
      el_32.appendChild(text);
      el_32.setAttribute("Erscheinungsjahr", "1973");
      el_32.setAttribute("Art", "Lyrikband");
      el_32 = doc.createElement("Werk");
      el_2.appendChild(el_32);
      text = doc.createTextNode("Die heimliche Freiheit der Einsamkeit");
      el_32.appendChild(text);
      el_32.setAttribute("Erscheinungsjahr", "1973-1988");
      el_32.setAttribute("Art", "Gedichtsammelband");

      // schriftsteller 3
      el_2 = doc.createElement("Schriftsteller");
      el_1.appendChild(el_2);
      el_31 = doc.createElement("Name");
      el_2.appendChild(el_31);
      text = doc.createTextNode("Rainer Kunze");
      el_31.appendChild(text);
      el_32 = doc.createElement("Werk");
      el_2.appendChild(el_32);
      text = doc.createTextNode("Die wunderbaren Jahre");
      el_32.appendChild(text);
      el_32.setAttribute("Erscheinungsjahr", "1976");
      el_32.setAttribute("Art", "Roman");
    }
    catch(DOMException domex)
    {
      System.out.println("DOMException: " + domex.getMessage());
    }
    // Ausgabe des XML-Dokuments
    try
    {
      FileWriter fw = new FileWriter("com\\herdt\\javxml\\kap06\\NeueSchriftsteller.xml", false);
      OutputFormat format = new OutputFormat(doc);
      format.setIndenting(true);
      format.setIndent(2);
      format.setLineSeparator("\r\n");
      format.setEncoding("ISO-8859-1");
      XMLSerializer serializer = new XMLSerializer(fw, format);
      serializer.serialize(doc);
      System.out.println("XML-Dokument erfolgreich erstellt.");
    }
    catch(IOException ioex)
    {
      System.out.println("IOException: " + ioex.getMessage());
    }
  }

}
