package com.herdt.javxml.kap09;

import org.apache.cocoon.generation.*;
import org.apache.cocoon.*;
import org.apache.avalon.framework.parameters.*;
import org.apache.cocoon.environment.*;
import org.xml.sax.helpers.*;
import org.xml.sax.*;
import java.util.*;
import java.io.*;

public class WochenTag extends AbstractGenerator
{
  private AttributesImpl emptyAttr = new AttributesImpl();
  private String[] DaysGerman = {"Montag", "Dienstag", "Mittwoch", "Donnerstag", "Freitag", "Sonnabend", "Sonntag"};
  private String[] DaysEnglish = {"Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday", "Sunday"};
  private String language = null;

  public void setup(SourceResolver resolver, Map objectModel, String src, Parameters params)
    throws ProcessingException, SAXException, IOException
  {
    Request requestData = ObjectModelHelper.getRequest(objectModel);
    language = requestData.getParameter("language");
    if(language.equals(null))
      language = "German";
  }

  public void generate() throws SAXException
  {
    contentHandler.startDocument();

    if(language.equals("German"))
    {
      contentHandler.startElement("", "Wochentage", "Wochentage", emptyAttr);

      for(int i = 0; i < DaysGerman.length; i++)
      {
        contentHandler.startElement("", "Tag", "Tag", emptyAttr);
        contentHandler.characters(DaysGerman[i].toCharArray(), 0, DaysGerman[i].length());
        contentHandler.endElement("", "Tag", "Tag");
      }

      contentHandler.endElement("", "Wochentage", "Wochentage");
    }
    else
    {
      contentHandler.startElement("", "Weekdays", "Weekdays", emptyAttr);

      for(int i = 0; i < DaysGerman.length; i++)
      {
        contentHandler.startElement("", "Day", "Day", emptyAttr);
        contentHandler.characters(DaysEnglish[i].toCharArray(), 0, DaysEnglish[i].length());
        contentHandler.endElement("", "Day", "Day");
      }

      contentHandler.endElement("", "Weekdays", "Weekdays");
    }

    contentHandler.endDocument();
  }
}
